Index: drivers/filesystems/btrfs/fsctl.c
===================================================================
--- drivers/filesystems/btrfs/fsctl.c	(révision 75772)
+++ drivers/filesystems/btrfs/fsctl.c	(copie de travail)
@@ -2842,17 +3089,1692 @@
 static NTSTATUS query_uuid(device_extension* Vcb, void* data, ULONG length) {
     if (length < sizeof(BTRFS_UUID))
         return STATUS_BUFFER_OVERFLOW;
-    
+
     RtlCopyMemory(data, &Vcb->superblock.uuid, sizeof(BTRFS_UUID));
-    
+
     return STATUS_SUCCESS;
 }
 
-NTSTATUS fsctl_request(PDEVICE_OBJECT DeviceObject, PIRP Irp, UINT32 type, BOOL user) {
+static NTSTATUS reset_stats(device_extension* Vcb, void* data, ULONG length, KPROCESSOR_MODE processor_mode) {
+    UINT64 devid;
+    NTSTATUS Status;
+    LIST_ENTRY* le;
+
+    if (length < sizeof(UINT64))
+        return STATUS_INVALID_PARAMETER;
+
+    if (Vcb->readonly)
+        return STATUS_MEDIA_WRITE_PROTECTED;
+
+    if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), processor_mode))
+        return STATUS_PRIVILEGE_NOT_HELD;
+
+    devid = *((UINT64*)data);
+
+    ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
+
+    le = Vcb->devices.Flink;
+
+    while (le != &Vcb->devices) {
+        device* dev = CONTAINING_RECORD(le, device, list_entry);
+
+        if (dev->devitem.dev_id == devid) {
+            RtlZeroMemory(dev->stats, sizeof(UINT64) * 5);
+            dev->stats_changed = TRUE;
+            Vcb->stats_changed = TRUE;
+            Vcb->need_write = TRUE;
+            Status = STATUS_SUCCESS;
+            goto end;
+        }
+
+        le = le->Flink;
+    }
+
+    WARN("device %llx not found\n", devid);
+    Status = STATUS_INVALID_PARAMETER;
+
+end:
+    ExReleaseResourceLite(&Vcb->tree_lock);
+
+    return Status;
+}
+
+static NTSTATUS get_integrity_information(device_extension* Vcb, PFILE_OBJECT FileObject, void* data, ULONG datalen) {
+    FSCTL_GET_INTEGRITY_INFORMATION_BUFFER* fgiib = (FSCTL_GET_INTEGRITY_INFORMATION_BUFFER*)data;
+
+    TRACE("FSCTL_GET_INTEGRITY_INFORMATION\n");
+
+    // STUB
+
+    if (!FileObject)
+        return STATUS_INVALID_PARAMETER;
+
+    if (!data || datalen < sizeof(FSCTL_GET_INTEGRITY_INFORMATION_BUFFER))
+        return STATUS_INVALID_PARAMETER;
+
+    fgiib->ChecksumAlgorithm = 0;
+    fgiib->Reserved = 0;
+    fgiib->Flags = 0;
+    fgiib->ChecksumChunkSizeInBytes = Vcb->superblock.sector_size;
+    fgiib->ClusterSizeInBytes = Vcb->superblock.sector_size;
+
+    return STATUS_SUCCESS;
+}
+
+static NTSTATUS set_integrity_information(PFILE_OBJECT FileObject, void* data, ULONG datalen) {
+    TRACE("FSCTL_SET_INTEGRITY_INFORMATION\n");
+
+    // STUB
+
+    if (!FileObject)
+        return STATUS_INVALID_PARAMETER;
+
+    if (!data || datalen < sizeof(FSCTL_SET_INTEGRITY_INFORMATION_BUFFER))
+        return STATUS_INVALID_PARAMETER;
+
+    return STATUS_SUCCESS;
+}
+
+BOOL fcb_is_inline(fcb* fcb) {
+    LIST_ENTRY* le;
+
+    le = fcb->extents.Flink;
+    while (le != &fcb->extents) {
+        extent* ext = CONTAINING_RECORD(le, extent, list_entry);
+
+        if (!ext->ignore)
+            return ext->extent_data.type == EXTENT_TYPE_INLINE;
+
+        le = le->Flink;
+    }
+
+    return FALSE;
+}
+
+static NTSTATUS duplicate_extents(device_extension* Vcb, PFILE_OBJECT FileObject, void* data, ULONG datalen, PIRP Irp) {
+    DUPLICATE_EXTENTS_DATA* ded = (DUPLICATE_EXTENTS_DATA*)data;
+    fcb *fcb = FileObject ? FileObject->FsContext : NULL, *sourcefcb;
+    ccb *ccb = FileObject ? FileObject->FsContext2 : NULL, *sourceccb;
+    NTSTATUS Status;
+    PFILE_OBJECT sourcefo;
+    UINT64 sourcelen, nbytes = 0;
+    LIST_ENTRY rollback, *le, newexts;
+    LARGE_INTEGER time;
+    BTRFS_TIME now;
+    BOOL make_inline;
+
+    if (!ded || datalen < sizeof(DUPLICATE_EXTENTS_DATA))
+        return STATUS_BUFFER_TOO_SMALL;
+
+    if (Vcb->readonly)
+        return STATUS_MEDIA_WRITE_PROTECTED;
+
+    if (ded->ByteCount.QuadPart == 0)
+        return STATUS_SUCCESS;
+
+    if (!fcb || !ccb || fcb == Vcb->volume_fcb)
+        return STATUS_INVALID_PARAMETER;
+
+    if (is_subvol_readonly(fcb->subvol, Irp))
+        return STATUS_ACCESS_DENIED;
+
+    if (Irp->RequestorMode == UserMode && !(ccb->access & FILE_WRITE_DATA)) {
+        WARN("insufficient privileges\n");
+        return STATUS_ACCESS_DENIED;
+    }
+
+    if (!fcb->ads && fcb->type != BTRFS_TYPE_FILE && fcb->type != BTRFS_TYPE_SYMLINK)
+        return STATUS_INVALID_PARAMETER;
+
+    Status = ObReferenceObjectByHandle(ded->FileHandle, 0, *IoFileObjectType, Irp->RequestorMode, (void**)&sourcefo, NULL);
+    if (!NT_SUCCESS(Status)) {
+        ERR("ObReferenceObjectByHandle returned %08x\n", Status);
+        return Status;
+    }
+
+    if (sourcefo->DeviceObject != FileObject->DeviceObject) {
+        WARN("source and destination are on different volumes\n");
+        ObDereferenceObject(sourcefo);
+        return STATUS_INVALID_PARAMETER;
+    }
+
+    sourcefcb = sourcefo->FsContext;
+    sourceccb = sourcefo->FsContext2;
+
+    if (!sourcefcb || !sourceccb || sourcefcb == Vcb->volume_fcb) {
+        ObDereferenceObject(sourcefo);
+        return STATUS_INVALID_PARAMETER;
+    }
+
+    if (!sourcefcb->ads && !fcb->ads) {
+        if ((ded->SourceFileOffset.QuadPart & (Vcb->superblock.sector_size - 1)) || (ded->TargetFileOffset.QuadPart & (Vcb->superblock.sector_size - 1))) {
+            ObDereferenceObject(sourcefo);
+            return STATUS_INVALID_PARAMETER;
+        }
+
+        if (ded->ByteCount.QuadPart & (Vcb->superblock.sector_size - 1)) {
+            ObDereferenceObject(sourcefo);
+            return STATUS_INVALID_PARAMETER;
+        }
+    }
+
+    if (Irp->RequestorMode == UserMode && (!(sourceccb->access & FILE_READ_DATA) || !(sourceccb->access & FILE_READ_ATTRIBUTES))) {
+        WARN("insufficient privileges\n");
+        ObDereferenceObject(sourcefo);
+        return STATUS_ACCESS_DENIED;
+    }
+
+    if (!sourcefcb->ads && sourcefcb->type != BTRFS_TYPE_FILE && sourcefcb->type != BTRFS_TYPE_SYMLINK) {
+        ObDereferenceObject(sourcefo);
+        return STATUS_INVALID_PARAMETER;
+    }
+
+    sourcelen = sourcefcb->ads ? sourcefcb->adsdata.Length : sourcefcb->inode_item.st_size;
+
+    if (sector_align(sourcelen, Vcb->superblock.sector_size) < (UINT64)ded->SourceFileOffset.QuadPart + (UINT64)ded->ByteCount.QuadPart) {
+        ObDereferenceObject(sourcefo);
+        return STATUS_NOT_SUPPORTED;
+    }
+
+    if (fcb == sourcefcb &&
+        ((ded->SourceFileOffset.QuadPart >= ded->TargetFileOffset.QuadPart && ded->SourceFileOffset.QuadPart < ded->TargetFileOffset.QuadPart + ded->ByteCount.QuadPart) ||
+        (ded->TargetFileOffset.QuadPart >= ded->SourceFileOffset.QuadPart && ded->TargetFileOffset.QuadPart < ded->SourceFileOffset.QuadPart + ded->ByteCount.QuadPart))) {
+        WARN("source and destination are the same, and the ranges overlap\n");
+        ObDereferenceObject(sourcefo);
+        return STATUS_INVALID_PARAMETER;
+    }
+
+    // fail if nocsum flag set on one file but not the other
+    if (!fcb->ads && !sourcefcb->ads && (fcb->inode_item.flags & BTRFS_INODE_NODATASUM) != (sourcefcb->inode_item.flags & BTRFS_INODE_NODATASUM)) {
+        ObDereferenceObject(sourcefo);
+        return STATUS_INVALID_PARAMETER;
+    }
+
+    InitializeListHead(&rollback);
+    InitializeListHead(&newexts);
+
+    ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
+
+    ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
+
+    if (fcb != sourcefcb)
+        ExAcquireResourceSharedLite(sourcefcb->Header.Resource, TRUE);
+
+    if (!FsRtlFastCheckLockForWrite(&fcb->lock, &ded->TargetFileOffset, &ded->ByteCount, 0, FileObject, PsGetCurrentProcess())) {
+        Status = STATUS_FILE_LOCK_CONFLICT;
+        goto end;
+    }
+
+    if (!FsRtlFastCheckLockForRead(&sourcefcb->lock, &ded->SourceFileOffset, &ded->ByteCount, 0, FileObject, PsGetCurrentProcess())) {
+        Status = STATUS_FILE_LOCK_CONFLICT;
+        goto end;
+    }
+
+    make_inline = fcb->ads ? FALSE : (fcb->inode_item.st_size <= Vcb->options.max_inline || fcb_is_inline(fcb));
+
+    if (fcb->ads || sourcefcb->ads || make_inline || fcb_is_inline(sourcefcb)) {
+        UINT8* data2;
+        ULONG bytes_read, dataoff, datalen2;
+
+        if (make_inline) {
+            dataoff = (ULONG)ded->TargetFileOffset.QuadPart;
+            datalen2 = (ULONG)fcb->inode_item.st_size;
+        } else if (fcb->ads) {
+            dataoff = 0;
+            datalen2 = (ULONG)ded->ByteCount.QuadPart;
+        } else {
+            dataoff = ded->TargetFileOffset.QuadPart % Vcb->superblock.sector_size;
+            datalen2 = (ULONG)sector_align(ded->ByteCount.QuadPart + dataoff, Vcb->superblock.sector_size);
+        }
+
+        data2 = ExAllocatePoolWithTag(PagedPool, datalen2, ALLOC_TAG);
+        if (!data2) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto end;
+        }
+
+        if (dataoff > 0) {
+            if (make_inline)
+                Status = read_file(fcb, data2, 0, datalen2, NULL, Irp);
+            else
+                Status = read_file(fcb, data2, ded->TargetFileOffset.QuadPart - dataoff, dataoff, NULL, Irp);
+
+            if (!NT_SUCCESS(Status)) {
+                ERR("read_file returned %08x\n", Status);
+                ExFreePool(data2);
+                goto end;
+            }
+        }
+
+        if (sourcefcb->ads) {
+            Status = read_stream(sourcefcb, data2 + dataoff, ded->SourceFileOffset.QuadPart, (ULONG)ded->ByteCount.QuadPart, &bytes_read);
+            if (!NT_SUCCESS(Status)) {
+                ERR("read_stream returned %08x\n", Status);
+                ExFreePool(data2);
+                goto end;
+            }
+        } else {
+            Status = read_file(sourcefcb, data2 + dataoff, ded->SourceFileOffset.QuadPart, ded->ByteCount.QuadPart, &bytes_read, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("read_file returned %08x\n", Status);
+                ExFreePool(data2);
+                goto end;
+            }
+        }
+
+        if (dataoff + bytes_read < datalen2)
+            RtlZeroMemory(data2 + dataoff + bytes_read, datalen2 - bytes_read);
+
+        if (fcb->ads)
+            RtlCopyMemory(&fcb->adsdata.Buffer[ded->TargetFileOffset.QuadPart], data2, (USHORT)min(ded->ByteCount.QuadPart, fcb->adsdata.Length - ded->TargetFileOffset.QuadPart));
+        else if (make_inline) {
+            UINT16 edsize;
+            EXTENT_DATA* ed;
+
+            Status = excise_extents(Vcb, fcb, 0, sector_align(fcb->inode_item.st_size, Vcb->superblock.sector_size), Irp, &rollback);
+            if (!NT_SUCCESS(Status)) {
+                ERR("excise_extents returned %08x\n", Status);
+                ExFreePool(data2);
+                goto end;
+            }
+
+            edsize = (UINT16)(offsetof(EXTENT_DATA, data[0]) + datalen2);
+
+            ed = ExAllocatePoolWithTag(PagedPool, edsize, ALLOC_TAG);
+            if (!ed) {
+                ERR("out of memory\n");
+                ExFreePool(data2);
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto end;
+            }
+
+            ed->generation = Vcb->superblock.generation;
+            ed->decoded_size = fcb->inode_item.st_size;
+            ed->compression = BTRFS_COMPRESSION_NONE;
+            ed->encryption = BTRFS_ENCRYPTION_NONE;
+            ed->encoding = BTRFS_ENCODING_NONE;
+            ed->type = EXTENT_TYPE_INLINE;
+
+            RtlCopyMemory(ed->data, data2, datalen2);
+
+            Status = add_extent_to_fcb(fcb, 0, ed, edsize, FALSE, NULL, &rollback);
+            if (!NT_SUCCESS(Status)) {
+                ERR("add_extent_to_fcb returned %08x\n", Status);
+                ExFreePool(data2);
+                goto end;
+            }
+
+            fcb->inode_item.st_blocks += datalen2;
+        } else {
+            UINT64 start = ded->TargetFileOffset.QuadPart - (ded->TargetFileOffset.QuadPart % Vcb->superblock.sector_size);
+
+            Status = do_write_file(fcb, start, start + datalen2, data2, Irp, FALSE, 0, &rollback);
+            if (!NT_SUCCESS(Status)) {
+                ERR("do_write_file returned %08x\n", Status);
+                ExFreePool(data2);
+                goto end;
+            }
+        }
+
+        ExFreePool(data2);
+    } else {
+        LIST_ENTRY* lastextle;
+
+        le = sourcefcb->extents.Flink;
+        while (le != &sourcefcb->extents) {
+            extent* ext = CONTAINING_RECORD(le, extent, list_entry);
+
+            if (!ext->ignore) {
+                if (ext->offset >= (UINT64)ded->SourceFileOffset.QuadPart + (UINT64)ded->ByteCount.QuadPart)
+                    break;
+
+                if (ext->extent_data.type != EXTENT_TYPE_INLINE) {
+                    ULONG extlen = offsetof(extent, extent_data) + sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2);
+                    extent* ext2;
+                    EXTENT_DATA2 *ed2s, *ed2d;
+                    chunk* c;
+
+                    ed2s = (EXTENT_DATA2*)ext->extent_data.data;
+
+                    if (ext->offset + ed2s->num_bytes <= (UINT64)ded->SourceFileOffset.QuadPart) {
+                        le = le->Flink;
+                        continue;
+                    }
+
+                    ext2 = ExAllocatePoolWithTag(PagedPool, extlen, ALLOC_TAG);
+                    if (!ext2) {
+                        ERR("out of memory\n");
+                        Status = STATUS_INSUFFICIENT_RESOURCES;
+                        goto end;
+                    }
+
+                    if (ext->offset < (UINT64)ded->SourceFileOffset.QuadPart)
+                        ext2->offset = ded->TargetFileOffset.QuadPart;
+                    else
+                        ext2->offset = ext->offset - ded->SourceFileOffset.QuadPart + ded->TargetFileOffset.QuadPart;
+
+                    ext2->datalen = sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2);
+                    ext2->unique = FALSE;
+                    ext2->ignore = FALSE;
+                    ext2->inserted = TRUE;
+
+                    ext2->extent_data.generation = Vcb->superblock.generation;
+                    ext2->extent_data.decoded_size = ext->extent_data.decoded_size;
+                    ext2->extent_data.compression = ext->extent_data.compression;
+                    ext2->extent_data.encryption = ext->extent_data.encryption;
+                    ext2->extent_data.encoding = ext->extent_data.encoding;
+                    ext2->extent_data.type = ext->extent_data.type;
+
+                    ed2d = (EXTENT_DATA2*)ext2->extent_data.data;
+
+                    ed2d->address = ed2s->address;
+                    ed2d->size = ed2s->size;
+
+                    if (ext->offset < (UINT64)ded->SourceFileOffset.QuadPart) {
+                        ed2d->offset = ed2s->offset + ded->SourceFileOffset.QuadPart - ext->offset;
+                        ed2d->num_bytes = min((UINT64)ded->ByteCount.QuadPart, ed2s->num_bytes + ext->offset - ded->SourceFileOffset.QuadPart);
+                    } else {
+                        ed2d->offset = ed2s->offset;
+                        ed2d->num_bytes = min(ded->SourceFileOffset.QuadPart + ded->ByteCount.QuadPart - ext->offset, ed2s->num_bytes);
+                    }
+
+                    if (ext->csum) {
+                        if (ext->extent_data.compression == BTRFS_COMPRESSION_NONE) {
+                            ext2->csum = ExAllocatePoolWithTag(PagedPool, (ULONG)(ed2d->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size), ALLOC_TAG);
+                            if (!ext2->csum) {
+                                ERR("out of memory\n");
+                                Status = STATUS_INSUFFICIENT_RESOURCES;
+                                ExFreePool(ext2);
+                                goto end;
+                            }
+
+                            RtlCopyMemory(ext2->csum, &ext->csum[(ed2d->offset - ed2s->offset) / Vcb->superblock.sector_size],
+                                          (ULONG)(ed2d->num_bytes * sizeof(UINT32) / Vcb->superblock.sector_size));
+                        } else {
+                            ext2->csum = ExAllocatePoolWithTag(PagedPool, (ULONG)(ed2d->size * sizeof(UINT32) / Vcb->superblock.sector_size), ALLOC_TAG);
+                            if (!ext2->csum) {
+                                ERR("out of memory\n");
+                                Status = STATUS_INSUFFICIENT_RESOURCES;
+                                ExFreePool(ext2);
+                                goto end;
+                            }
+
+                            RtlCopyMemory(ext2->csum, ext->csum, (ULONG)(ed2s->size * sizeof(UINT32) / Vcb->superblock.sector_size));
+                        }
+                    } else
+                        ext2->csum = NULL;
+
+                    InsertTailList(&newexts, &ext2->list_entry);
+
+                    c = get_chunk_from_address(Vcb, ed2s->address);
+                    if (!c) {
+                        ERR("get_chunk_from_address(%llx) failed\n", ed2s->address);
+                        Status = STATUS_INTERNAL_ERROR;
+                        goto end;
+                    }
+
+                    Status = update_changed_extent_ref(Vcb, c, ed2s->address, ed2s->size, fcb->subvol->id, fcb->inode, ext2->offset - ed2d->offset,
+                                                    1, fcb->inode_item.flags & BTRFS_INODE_NODATASUM, FALSE, Irp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("update_changed_extent_ref returned %08x\n", Status);
+                        goto end;
+                    }
+
+                    nbytes += ed2d->num_bytes;
+                }
+            }
+
+            le = le->Flink;
+        }
+
+        Status = excise_extents(Vcb, fcb, ded->TargetFileOffset.QuadPart, ded->TargetFileOffset.QuadPart + ded->ByteCount.QuadPart, Irp, &rollback);
+        if (!NT_SUCCESS(Status)) {
+            ERR("excise_extents returned %08x\n", Status);
+
+            while (!IsListEmpty(&newexts)) {
+                extent* ext = CONTAINING_RECORD(RemoveHeadList(&newexts), extent, list_entry);
+                ExFreePool(ext);
+            }
+
+            goto end;
+        }
+
+        // clear unique flags in source fcb
+        le = sourcefcb->extents.Flink;
+        while (le != &sourcefcb->extents) {
+            extent* ext = CONTAINING_RECORD(le, extent, list_entry);
+
+            if (!ext->ignore && ext->unique && (ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC)) {
+                EXTENT_DATA2* ed2s = (EXTENT_DATA2*)ext->extent_data.data;
+                LIST_ENTRY* le2;
+
+                le2 = newexts.Flink;
+                while (le2 != &newexts) {
+                    extent* ext2 = CONTAINING_RECORD(le2, extent, list_entry);
+
+                    if (ext2->extent_data.type == EXTENT_TYPE_REGULAR || ext2->extent_data.type == EXTENT_TYPE_PREALLOC) {
+                        EXTENT_DATA2* ed2d = (EXTENT_DATA2*)ext2->extent_data.data;
+
+                        if (ed2d->address == ed2s->address && ed2d->size == ed2s->size) {
+                            ext->unique = FALSE;
+                            break;
+                        }
+                    }
+
+                    le2 = le2->Flink;
+                }
+            }
+
+            le = le->Flink;
+        }
+
+        lastextle = &fcb->extents;
+        while (!IsListEmpty(&newexts)) {
+            extent* ext = CONTAINING_RECORD(RemoveHeadList(&newexts), extent, list_entry);
+
+            add_extent(fcb, lastextle, ext);
+            lastextle = &ext->list_entry;
+        }
+    }
+
+    KeQuerySystemTime(&time);
+    win_time_to_unix(time, &now);
+
+    if (fcb->ads) {
+        ccb->fileref->parent->fcb->inode_item.sequence++;
+
+        if (!ccb->user_set_change_time)
+            ccb->fileref->parent->fcb->inode_item.st_ctime = now;
+
+        ccb->fileref->parent->fcb->inode_item_changed = TRUE;
+        mark_fcb_dirty(ccb->fileref->parent->fcb);
+    } else {
+        fcb->inode_item.st_blocks += nbytes;
+        fcb->inode_item.sequence++;
+
+        if (!ccb->user_set_change_time)
+            fcb->inode_item.st_ctime = now;
+
+        if (!ccb->user_set_write_time) {
+            fcb->inode_item.st_mtime = now;
+            send_notification_fcb(ccb->fileref, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED, NULL);
+        }
+
+        fcb->inode_item_changed = TRUE;
+        fcb->extents_changed = TRUE;
+    }
+
+    mark_fcb_dirty(fcb);
+
+    if (fcb->nonpaged->segment_object.DataSectionObject)
+        CcPurgeCacheSection(&fcb->nonpaged->segment_object, &ded->TargetFileOffset, (ULONG)ded->ByteCount.QuadPart, FALSE);
+
+    Status = STATUS_SUCCESS;
+
+end:
+    ObDereferenceObject(sourcefo);
+
+    if (NT_SUCCESS(Status))
+        clear_rollback(&rollback);
+    else
+        do_rollback(Vcb, &rollback);
+
+    if (fcb != sourcefcb)
+        ExReleaseResourceLite(sourcefcb->Header.Resource);
+
+    ExReleaseResourceLite(fcb->Header.Resource);
+
+    ExReleaseResourceLite(&Vcb->tree_lock);
+
+    return Status;
+}
+
+// based on functions in sys/sysmacros.h
+#define major(rdev) ((((rdev) >> 8) & 0xFFF) | ((UINT32)((rdev) >> 32) & ~0xFFF))
+#define minor(rdev) (((rdev) & 0xFF) | ((UINT32)((rdev) >> 12) & ~0xFF))
+
+static NTSTATUS mknod(device_extension* Vcb, PFILE_OBJECT FileObject, void* data, ULONG datalen, PIRP Irp) {
+    NTSTATUS Status;
+    btrfs_mknod* bmn;
+    fcb *parfcb, *fcb;
+    ccb* parccb;
+    file_ref *parfileref, *fileref;
+    UNICODE_STRING name;
+    root* subvol;
+    UINT64 inode;
+    dir_child* dc;
+    LARGE_INTEGER time;
+    BTRFS_TIME now;
+    LIST_ENTRY* lastle;
+    ANSI_STRING utf8;
+    ULONG len, i;
+    SECURITY_SUBJECT_CONTEXT subjcont;
+    PSID owner;
+    BOOLEAN defaulted;
+
+    TRACE("(%p, %p, %p, %u)\n", Vcb, FileObject, data, datalen);
+
+    if (!FileObject || !FileObject->FsContext || !FileObject->FsContext2 || FileObject->FsContext == Vcb->volume_fcb)
+        return STATUS_INVALID_PARAMETER;
+
+    if (Vcb->readonly)
+        return STATUS_MEDIA_WRITE_PROTECTED;
+
+    parfcb = FileObject->FsContext;
+
+    if (parfcb->type != BTRFS_TYPE_DIRECTORY) {
+        WARN("trying to create file in something other than a directory\n");
+        return STATUS_INVALID_PARAMETER;
+    }
+
+    if (is_subvol_readonly(parfcb->subvol, Irp))
+        return STATUS_ACCESS_DENIED;
+
+    parccb = FileObject->FsContext2;
+    parfileref = parccb->fileref;
+
+    if (!parfileref)
+        return STATUS_INVALID_PARAMETER;
+
+    if (datalen < sizeof(btrfs_mknod))
+        return STATUS_INVALID_PARAMETER;
+
+    bmn = (btrfs_mknod*)data;
+
+    if (datalen < offsetof(btrfs_mknod, name[0]) + bmn->namelen || bmn->namelen < sizeof(WCHAR))
+        return STATUS_INVALID_PARAMETER;
+
+    if (bmn->type == BTRFS_TYPE_UNKNOWN || bmn->type > BTRFS_TYPE_SYMLINK)
+        return STATUS_INVALID_PARAMETER;
+
+    if ((bmn->type == BTRFS_TYPE_DIRECTORY && !(parccb->access & FILE_ADD_SUBDIRECTORY)) ||
+        (bmn->type != BTRFS_TYPE_DIRECTORY && !(parccb->access & FILE_ADD_FILE))) {
+        WARN("insufficient privileges\n");
+        return STATUS_ACCESS_DENIED;
+    }
+
+    if (bmn->inode != 0) {
+        if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), Irp->RequestorMode))
+            return STATUS_PRIVILEGE_NOT_HELD;
+    }
+
+    for (i = 0; i < bmn->namelen / sizeof(WCHAR); i++) {
+        if (bmn->name[i] == 0 || bmn->name[i] == '/')
+            return STATUS_OBJECT_NAME_INVALID;
+    }
+
+    // don't allow files called . or ..
+    if (bmn->name[0] == '.' && (bmn->namelen == sizeof(WCHAR) || (bmn->namelen == 2 * sizeof(WCHAR) && bmn->name[1] == '.')))
+        return STATUS_OBJECT_NAME_INVALID;
+
+    Status = RtlUnicodeToUTF8N(NULL, 0, &len, bmn->name, bmn->namelen);
+    if (!NT_SUCCESS(Status)) {
+        ERR("RtlUnicodeToUTF8N return %08x\n", Status);
+        return Status;
+    }
+
+    if (len == 0) {
+        ERR("RtlUnicodeToUTF8N returned a length of 0\n");
+        return STATUS_INTERNAL_ERROR;
+    }
+
+    if (len > 0xffff) {
+        ERR("len was too long (%x)\n", len);
+        return STATUS_INVALID_PARAMETER;
+    }
+
+    utf8.MaximumLength = utf8.Length = (USHORT)len;
+    utf8.Buffer = ExAllocatePoolWithTag(PagedPool, utf8.MaximumLength, ALLOC_TAG);
+
+    if (!utf8.Buffer) {
+        ERR("out of memory\n");
+        return STATUS_INSUFFICIENT_RESOURCES;
+    }
+
+    Status = RtlUnicodeToUTF8N(utf8.Buffer, len, &len, bmn->name, bmn->namelen);
+    if (!NT_SUCCESS(Status)) {
+        ERR("RtlUnicodeToUTF8N failed with error %08x\n", Status);
+        ExFreePool(utf8.Buffer);
+        return Status;
+    }
+
+    name.Length = name.MaximumLength = bmn->namelen;
+    name.Buffer = bmn->name;
+
+    ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
+
+    Status = find_file_in_dir(&name, parfcb, &subvol, &inode, &dc, TRUE);
+    if (!NT_SUCCESS(Status) && Status != STATUS_OBJECT_NAME_NOT_FOUND) {
+        ERR("find_file_in_dir returned %08x\n", Status);
+        goto end;
+    }
+
+    if (NT_SUCCESS(Status)) {
+        WARN("filename already exists\n");
+        Status = STATUS_OBJECT_NAME_COLLISION;
+        goto end;
+    }
+
+    if (bmn->inode == 0) {
+        inode = InterlockedIncrement64(&parfcb->subvol->lastinode);
+        lastle = parfcb->subvol->fcbs.Blink;
+    } else {
+        if (bmn->inode > (UINT64)parfcb->subvol->lastinode) {
+            inode = parfcb->subvol->lastinode = bmn->inode;
+            lastle = parfcb->subvol->fcbs.Blink;
+        } else {
+            LIST_ENTRY* le = parfcb->subvol->fcbs.Flink;
+
+            lastle = parfcb->subvol->fcbs.Blink;;
+            while (le != &parfcb->subvol->fcbs) {
+                struct _fcb* fcb2 = CONTAINING_RECORD(le, struct _fcb, list_entry);
+
+                if (fcb2->inode == bmn->inode && !fcb2->deleted) {
+                    WARN("inode collision\n");
+                    Status = STATUS_INVALID_PARAMETER;
+                    goto end;
+                } else if (fcb2->inode > bmn->inode) {
+                    lastle = fcb2->list_entry.Blink;
+                    break;
+                }
+
+                le = le->Flink;
+            }
+
+            inode = bmn->inode;
+        }
+    }
+
+    KeQuerySystemTime(&time);
+    win_time_to_unix(time, &now);
+
+    fcb = create_fcb(Vcb, PagedPool);
+    if (!fcb) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto end;
+    }
+
+    fcb->Vcb = Vcb;
+
+    fcb->inode_item.generation = Vcb->superblock.generation;
+    fcb->inode_item.transid = Vcb->superblock.generation;
+    fcb->inode_item.st_size = 0;
+    fcb->inode_item.st_blocks = 0;
+    fcb->inode_item.block_group = 0;
+    fcb->inode_item.st_nlink = 1;
+    fcb->inode_item.st_uid = UID_NOBODY;
+    fcb->inode_item.st_gid = GID_NOBODY;
+    fcb->inode_item.st_mode = inherit_mode(parfcb, bmn->type == BTRFS_TYPE_DIRECTORY);
+
+    if (bmn->type == BTRFS_TYPE_BLOCKDEV || bmn->type == BTRFS_TYPE_CHARDEV)
+        fcb->inode_item.st_rdev = (minor(bmn->st_rdev) & 0xFFFFF) | ((major(bmn->st_rdev) & 0xFFFFFFFFFFF) << 20);
+    else
+        fcb->inode_item.st_rdev = 0;
+
+    fcb->inode_item.flags = 0;
+    fcb->inode_item.sequence = 1;
+    fcb->inode_item.st_atime = now;
+    fcb->inode_item.st_ctime = now;
+    fcb->inode_item.st_mtime = now;
+    fcb->inode_item.otime = now;
+
+    if (bmn->type == BTRFS_TYPE_DIRECTORY)
+        fcb->inode_item.st_mode |= __S_IFDIR;
+    else if (bmn->type == BTRFS_TYPE_CHARDEV)
+        fcb->inode_item.st_mode |= __S_IFCHR;
+    else if (bmn->type == BTRFS_TYPE_BLOCKDEV)
+        fcb->inode_item.st_mode |= __S_IFBLK;
+    else if (bmn->type == BTRFS_TYPE_FIFO)
+        fcb->inode_item.st_mode |= __S_IFIFO;
+    else if (bmn->type == BTRFS_TYPE_SOCKET)
+        fcb->inode_item.st_mode |= __S_IFSOCK;
+    else if (bmn->type == BTRFS_TYPE_SYMLINK)
+        fcb->inode_item.st_mode |= __S_IFLNK;
+    else
+        fcb->inode_item.st_mode |= __S_IFREG;
+
+    if (bmn->type != BTRFS_TYPE_DIRECTORY)
+        fcb->inode_item.st_mode &= ~(S_IXUSR | S_IXGRP | S_IXOTH); // remove executable bit if not directory
+
+    // inherit nodatacow flag from parent directory
+    if (parfcb->inode_item.flags & BTRFS_INODE_NODATACOW) {
+        fcb->inode_item.flags |= BTRFS_INODE_NODATACOW;
+
+        if (bmn->type != BTRFS_TYPE_DIRECTORY)
+            fcb->inode_item.flags |= BTRFS_INODE_NODATASUM;
+    }
+
+    if (parfcb->inode_item.flags & BTRFS_INODE_COMPRESS)
+        fcb->inode_item.flags |= BTRFS_INODE_COMPRESS;
+
+    fcb->prop_compression = parfcb->prop_compression;
+    fcb->prop_compression_changed = fcb->prop_compression != PropCompression_None;
+
+    fcb->inode_item_changed = TRUE;
+
+    fcb->Header.IsFastIoPossible = fast_io_possible(fcb);
+    fcb->Header.AllocationSize.QuadPart = 0;
+    fcb->Header.FileSize.QuadPart = 0;
+    fcb->Header.ValidDataLength.QuadPart = 0;
+
+    fcb->atts = 0;
+
+    if (bmn->name[0] == '.')
+        fcb->atts |= FILE_ATTRIBUTE_HIDDEN;
+
+    if (bmn->type == BTRFS_TYPE_DIRECTORY)
+        fcb->atts |= FILE_ATTRIBUTE_DIRECTORY;
+
+    fcb->atts_changed = FALSE;
+
+    InterlockedIncrement(&parfcb->refcount);
+    fcb->subvol = parfcb->subvol;
+    fcb->inode = inode;
+    fcb->type = bmn->type;
+
+    SeCaptureSubjectContext(&subjcont);
+
+    Status = SeAssignSecurityEx(parfileref ? parfileref->fcb->sd : NULL, NULL, (void**)&fcb->sd, NULL, fcb->type == BTRFS_TYPE_DIRECTORY,
+                                SEF_SACL_AUTO_INHERIT, &subjcont, IoGetFileObjectGenericMapping(), PagedPool);
+
+    if (!NT_SUCCESS(Status)) {
+        ERR("SeAssignSecurityEx returned %08x\n", Status);
+        free_fcb(Vcb, fcb);
+        goto end;
+    }
+
+    Status = RtlGetOwnerSecurityDescriptor(fcb->sd, &owner, &defaulted);
+    if (!NT_SUCCESS(Status)) {
+        WARN("RtlGetOwnerSecurityDescriptor returned %08x\n", Status);
+        fcb->sd_dirty = TRUE;
+    } else {
+        fcb->inode_item.st_uid = sid_to_uid(owner);
+        fcb->sd_dirty = fcb->inode_item.st_uid == UID_NOBODY;
+    }
+
+    find_gid(fcb, parfcb, &subjcont);
+
+    fileref = create_fileref(Vcb);
+    if (!fileref) {
+        ERR("out of memory\n");
+        free_fcb(Vcb, fcb);
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto end;
+    }
+
+    fileref->fcb = fcb;
+
+    fcb->created = TRUE;
+    mark_fcb_dirty(fcb);
+
+    fileref->created = TRUE;
+    mark_fileref_dirty(fileref);
+
+    fcb->subvol->root_item.ctransid = Vcb->superblock.generation;
+    fcb->subvol->root_item.ctime = now;
+
+    fileref->parent = parfileref;
+
+    Status = add_dir_child(fileref->parent->fcb, fcb->inode, FALSE, &utf8, &name, fcb->type, &dc);
+    if (!NT_SUCCESS(Status))
+        WARN("add_dir_child returned %08x\n", Status);
+
+    fileref->dc = dc;
+    dc->fileref = fileref;
+
+    ExAcquireResourceExclusiveLite(&parfileref->nonpaged->children_lock, TRUE);
+    InsertTailList(&parfileref->children, &fileref->list_entry);
+    ExReleaseResourceLite(&parfileref->nonpaged->children_lock);
+
+    increase_fileref_refcount(parfileref);
+
+    if (fcb->type == BTRFS_TYPE_DIRECTORY) {
+        fcb->hash_ptrs = ExAllocatePoolWithTag(PagedPool, sizeof(LIST_ENTRY*) * 256, ALLOC_TAG);
+        if (!fcb->hash_ptrs) {
+            ERR("out of memory\n");
+            free_fileref(Vcb, fileref);
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto end;
+        }
+
+        RtlZeroMemory(fcb->hash_ptrs, sizeof(LIST_ENTRY*) * 256);
+
+        fcb->hash_ptrs_uc = ExAllocatePoolWithTag(PagedPool, sizeof(LIST_ENTRY*) * 256, ALLOC_TAG);
+        if (!fcb->hash_ptrs_uc) {
+            ERR("out of memory\n");
+            free_fileref(Vcb, fileref);
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto end;
+        }
+
+        RtlZeroMemory(fcb->hash_ptrs_uc, sizeof(LIST_ENTRY*) * 256);
+    }
+
+    InsertHeadList(lastle, &fcb->list_entry);
+    InsertTailList(&Vcb->all_fcbs, &fcb->list_entry_all);
+
+    if (bmn->type == BTRFS_TYPE_DIRECTORY)
+        fileref->fcb->fileref = fileref;
+
+    ExAcquireResourceExclusiveLite(parfcb->Header.Resource, TRUE);
+    parfcb->inode_item.st_size += utf8.Length * 2;
+    parfcb->inode_item.transid = Vcb->superblock.generation;
+    parfcb->inode_item.sequence++;
+
+    if (!parccb->user_set_change_time)
+        parfcb->inode_item.st_ctime = now;
+
+    if (!parccb->user_set_write_time)
+        parfcb->inode_item.st_mtime = now;
+
+    ExReleaseResourceLite(parfcb->Header.Resource);
+
+    parfcb->inode_item_changed = TRUE;
+    mark_fcb_dirty(parfcb);
+
+    send_notification_fileref(fileref, bmn->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_ADDED, NULL);
+
+    if (!parccb->user_set_write_time)
+        send_notification_fcb(parfileref, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED, NULL);
+
+    Status = STATUS_SUCCESS;
+
+end:
+    ExReleaseResourceLite(&Vcb->fcb_lock);
+
+    ExFreePool(utf8.Buffer);
+
+    return Status;
+}
+
+static void mark_subvol_dirty(device_extension* Vcb, root* r) {
+    if (!r->dirty) {
+        r->dirty = TRUE;
+
+        ExAcquireResourceExclusiveLite(&Vcb->dirty_subvols_lock, TRUE);
+        InsertTailList(&Vcb->dirty_subvols, &r->list_entry_dirty);
+        ExReleaseResourceLite(&Vcb->dirty_subvols_lock);
+    }
+
+    Vcb->need_write = TRUE;
+}
+
+static NTSTATUS recvd_subvol(device_extension* Vcb, PFILE_OBJECT FileObject, void* data, ULONG datalen, KPROCESSOR_MODE processor_mode) {
+    btrfs_received_subvol* brs = (btrfs_received_subvol*)data;
+    fcb* fcb;
+    NTSTATUS Status;
+    LARGE_INTEGER time;
+    BTRFS_TIME now;
+
+    TRACE("(%p, %p, %p, %u)\n", Vcb, FileObject, data, datalen);
+
+    if (!data || datalen < sizeof(btrfs_received_subvol))
+        return STATUS_INVALID_PARAMETER;
+
+    if (!FileObject || !FileObject->FsContext || FileObject->FsContext == Vcb->volume_fcb)
+        return STATUS_INVALID_PARAMETER;
+
+    fcb = FileObject->FsContext;
+
+    if (!fcb->subvol)
+        return STATUS_INVALID_PARAMETER;
+
+    if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), processor_mode))
+        return STATUS_PRIVILEGE_NOT_HELD;
+
+    ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
+
+    if (fcb->subvol->root_item.rtransid != 0) {
+        WARN("subvol already has received information set\n");
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
+    }
+
+    KeQuerySystemTime(&time);
+    win_time_to_unix(time, &now);
+
+    RtlCopyMemory(&fcb->subvol->root_item.received_uuid, &brs->uuid, sizeof(BTRFS_UUID));
+    fcb->subvol->root_item.stransid = brs->generation;
+    fcb->subvol->root_item.rtransid = Vcb->superblock.generation;
+    fcb->subvol->root_item.rtime = now;
+
+    fcb->subvol->received = TRUE;
+    mark_subvol_dirty(Vcb, fcb->subvol);
+
+    Status = STATUS_SUCCESS;
+
+end:
+    ExReleaseResourceLite(&Vcb->tree_lock);
+
+    return Status;
+}
+
+static NTSTATUS fsctl_get_xattrs(device_extension* Vcb, PFILE_OBJECT FileObject, void* data, ULONG datalen, KPROCESSOR_MODE processor_mode) {
+    LIST_ENTRY* le;
+    btrfs_set_xattr* bsxa;
+    ULONG reqlen = (ULONG)offsetof(btrfs_set_xattr, data[0]);
+    fcb* fcb;
+    ccb* ccb;
+
+    if (!data || datalen < reqlen)
+        return STATUS_INVALID_PARAMETER;
+
+    if (!FileObject || !FileObject->FsContext || !FileObject->FsContext2 || FileObject->FsContext == Vcb->volume_fcb)
+        return STATUS_INVALID_PARAMETER;
+
+    fcb = FileObject->FsContext;
+    ccb = FileObject->FsContext2;
+
+    if (!(ccb->access & (FILE_READ_ATTRIBUTES | FILE_WRITE_ATTRIBUTES)) && processor_mode == UserMode) {
+        WARN("insufficient privileges\n");
+        return STATUS_ACCESS_DENIED;
+    }
+
+    ExAcquireResourceSharedLite(fcb->Header.Resource, TRUE);
+
+    le = fcb->xattrs.Flink;
+    while (le != &fcb->xattrs) {
+        xattr* xa = CONTAINING_RECORD(le, xattr, list_entry);
+
+        if (xa->valuelen > 0)
+            reqlen += (ULONG)offsetof(btrfs_set_xattr, data[0]) + xa->namelen + xa->valuelen;
+
+        le = le->Flink;
+    }
+
+    if (datalen < reqlen) {
+        ExReleaseResourceLite(fcb->Header.Resource);
+        return STATUS_BUFFER_OVERFLOW;
+    }
+
+    bsxa = (btrfs_set_xattr*)data;
+
+    if (reqlen > 0) {
+        le = fcb->xattrs.Flink;
+        while (le != &fcb->xattrs) {
+            xattr* xa = CONTAINING_RECORD(le, xattr, list_entry);
+
+            if (xa->valuelen > 0) {
+                bsxa->namelen = xa->namelen;
+                bsxa->valuelen = xa->valuelen;
+                memcpy(bsxa->data, xa->data, xa->namelen + xa->valuelen);
+
+                bsxa = (btrfs_set_xattr*)&bsxa->data[xa->namelen + xa->valuelen];
+            }
+
+            le = le->Flink;
+        }
+    }
+
+    bsxa->namelen = 0;
+    bsxa->valuelen = 0;
+
+    ExReleaseResourceLite(fcb->Header.Resource);
+
+    return STATUS_SUCCESS;
+}
+
+static NTSTATUS fsctl_set_xattr(device_extension* Vcb, PFILE_OBJECT FileObject, void* data, ULONG datalen, PIRP Irp) {
+    NTSTATUS Status;
+    btrfs_set_xattr* bsxa;
+    xattr* xa;
+    fcb* fcb;
+    ccb* ccb;
+    LIST_ENTRY* le;
+
+    static const char stream_pref[] = "user.";
+
+    TRACE("(%p, %p, %p, %u)\n", Vcb, FileObject, data, datalen);
+
+    if (!data || datalen < sizeof(btrfs_set_xattr))
+        return STATUS_INVALID_PARAMETER;
+
+    bsxa = (btrfs_set_xattr*)data;
+
+    if (datalen < offsetof(btrfs_set_xattr, data[0]) + bsxa->namelen + bsxa->valuelen)
+        return STATUS_INVALID_PARAMETER;
+
+    if (bsxa->namelen + bsxa->valuelen + sizeof(tree_header) + sizeof(leaf_node) + offsetof(DIR_ITEM, name[0]) > Vcb->superblock.node_size)
+        return STATUS_INVALID_PARAMETER;
+
+    if (!FileObject || !FileObject->FsContext || !FileObject->FsContext2 || FileObject->FsContext == Vcb->volume_fcb)
+        return STATUS_INVALID_PARAMETER;
+
+    if (Vcb->readonly)
+        return STATUS_MEDIA_WRITE_PROTECTED;
+
+    fcb = FileObject->FsContext;
+    ccb = FileObject->FsContext2;
+
+    if (is_subvol_readonly(fcb->subvol, Irp))
+        return STATUS_ACCESS_DENIED;
+
+    if (!(ccb->access & FILE_WRITE_ATTRIBUTES) && Irp->RequestorMode == UserMode) {
+        WARN("insufficient privileges\n");
+        return STATUS_ACCESS_DENIED;
+    }
+
+    ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
+
+    ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
+
+    if (bsxa->namelen == strlen(EA_NTACL) && RtlCompareMemory(bsxa->data, EA_NTACL, strlen(EA_NTACL)) == strlen(EA_NTACL)) {
+        if ((!(ccb->access & WRITE_DAC) || !(ccb->access & WRITE_OWNER)) && Irp->RequestorMode == UserMode) {
+            WARN("insufficient privileges\n");
+            Status = STATUS_ACCESS_DENIED;
+            goto end;
+        }
+
+        if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), Irp->RequestorMode)) {
+            Status = STATUS_PRIVILEGE_NOT_HELD;
+            goto end;
+        }
+
+        if (fcb->sd)
+            ExFreePool(fcb->sd);
+
+        if (bsxa->valuelen > 0 && RtlValidRelativeSecurityDescriptor(bsxa->data + bsxa->namelen, bsxa->valuelen, 0)) {
+            fcb->sd = ExAllocatePoolWithTag(PagedPool, bsxa->valuelen, ALLOC_TAG);
+            if (!fcb->sd) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto end;
+            }
+
+            RtlCopyMemory(fcb->sd, bsxa->data + bsxa->namelen, bsxa->valuelen);
+        } else if (fcb->sd)
+            fcb->sd = NULL;
+
+        fcb->sd_dirty = TRUE;
+
+        if (!fcb->sd) {
+            fcb_get_sd(fcb, ccb->fileref->parent->fcb, FALSE, Irp);
+            fcb->sd_deleted = TRUE;
+        }
+
+        mark_fcb_dirty(fcb);
+
+        Status = STATUS_SUCCESS;
+        goto end;
+    } else if (bsxa->namelen == strlen(EA_DOSATTRIB) && RtlCompareMemory(bsxa->data, EA_DOSATTRIB, strlen(EA_DOSATTRIB)) == strlen(EA_DOSATTRIB)) {
+        ULONG atts;
+
+        if (bsxa->valuelen > 0 && get_file_attributes_from_xattr(bsxa->data + bsxa->namelen, bsxa->valuelen, &atts)) {
+            fcb->atts = atts;
+
+            if (fcb->type == BTRFS_TYPE_DIRECTORY)
+                fcb->atts |= FILE_ATTRIBUTE_DIRECTORY;
+            else if (fcb->type == BTRFS_TYPE_SYMLINK)
+                fcb->atts |= FILE_ATTRIBUTE_REPARSE_POINT;
+
+            if (fcb->inode == SUBVOL_ROOT_INODE) {
+                if (fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY)
+                    fcb->atts |= FILE_ATTRIBUTE_READONLY;
+                else
+                    fcb->atts &= ~FILE_ATTRIBUTE_READONLY;
+            }
+
+            fcb->atts_deleted = FALSE;
+        } else {
+            BOOL hidden = ccb->fileref && ccb->fileref->dc && ccb->fileref->dc->utf8.Buffer && ccb->fileref->dc->utf8.Buffer[0] == '.';
+
+            fcb->atts = get_file_attributes(Vcb, fcb->subvol, fcb->inode, fcb->type, hidden, TRUE, Irp);
+            fcb->atts_deleted = TRUE;
+        }
+
+        fcb->atts_changed = TRUE;
+        mark_fcb_dirty(fcb);
+
+        Status = STATUS_SUCCESS;
+        goto end;
+    } else if (bsxa->namelen == strlen(EA_REPARSE) && RtlCompareMemory(bsxa->data, EA_REPARSE, strlen(EA_REPARSE)) == strlen(EA_REPARSE)) {
+        if (fcb->reparse_xattr.Buffer) {
+            ExFreePool(fcb->reparse_xattr.Buffer);
+            fcb->reparse_xattr.Buffer = NULL;
+            fcb->reparse_xattr.Length = fcb->reparse_xattr.MaximumLength = 0;
+        }
+
+        if (bsxa->valuelen > 0) {
+            fcb->reparse_xattr.Buffer = ExAllocatePoolWithTag(PagedPool, bsxa->valuelen, ALLOC_TAG);
+            if (!fcb->reparse_xattr.Buffer) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto end;
+            }
+
+            RtlCopyMemory(fcb->reparse_xattr.Buffer, bsxa->data + bsxa->namelen, bsxa->valuelen);
+            fcb->reparse_xattr.Length = fcb->reparse_xattr.MaximumLength = bsxa->valuelen;
+        }
+
+        fcb->reparse_xattr_changed = TRUE;
+        mark_fcb_dirty(fcb);
+
+        Status = STATUS_SUCCESS;
+        goto end;
+    } else if (bsxa->namelen == strlen(EA_EA) && RtlCompareMemory(bsxa->data, EA_EA, strlen(EA_EA)) == strlen(EA_EA)) {
+        if (!(ccb->access & FILE_WRITE_EA) && Irp->RequestorMode == UserMode) {
+            WARN("insufficient privileges\n");
+            Status = STATUS_ACCESS_DENIED;
+            goto end;
+        }
+
+        if (fcb->ea_xattr.Buffer) {
+            ExFreePool(fcb->ea_xattr.Buffer);
+            fcb->ea_xattr.Length = fcb->ea_xattr.MaximumLength = 0;
+            fcb->ea_xattr.Buffer = NULL;
+        }
+
+        fcb->ealen = 0;
+
+        if (bsxa->valuelen > 0) {
+            ULONG offset;
+
+            Status = IoCheckEaBufferValidity((FILE_FULL_EA_INFORMATION*)(bsxa->data + bsxa->namelen), bsxa->valuelen, &offset);
+
+            if (!NT_SUCCESS(Status))
+                WARN("IoCheckEaBufferValidity returned %08x (error at offset %u)\n", Status, offset);
+            else {
+                FILE_FULL_EA_INFORMATION* eainfo;
+
+                fcb->ea_xattr.Buffer = ExAllocatePoolWithTag(PagedPool, bsxa->valuelen, ALLOC_TAG);
+                if (!fcb->ea_xattr.Buffer) {
+                    ERR("out of memory\n");
+                    Status = STATUS_INSUFFICIENT_RESOURCES;
+                    goto end;
+                }
+
+                RtlCopyMemory(fcb->ea_xattr.Buffer, bsxa->data + bsxa->namelen, bsxa->valuelen);
+
+                fcb->ea_xattr.Length = fcb->ea_xattr.MaximumLength = bsxa->valuelen;
+
+                fcb->ealen = 4;
+
+                // calculate ealen
+                eainfo = (FILE_FULL_EA_INFORMATION*)(bsxa->data + bsxa->namelen);
+                do {
+                    fcb->ealen += 5 + eainfo->EaNameLength + eainfo->EaValueLength;
+
+                    if (eainfo->NextEntryOffset == 0)
+                        break;
+
+                    eainfo = (FILE_FULL_EA_INFORMATION*)(((UINT8*)eainfo) + eainfo->NextEntryOffset);
+                } while (TRUE);
+            }
+        }
+
+        fcb->ea_changed = TRUE;
+        mark_fcb_dirty(fcb);
+
+        Status = STATUS_SUCCESS;
+        goto end;
+    } else if (bsxa->namelen == strlen(EA_PROP_COMPRESSION) && RtlCompareMemory(bsxa->data, EA_PROP_COMPRESSION, strlen(EA_PROP_COMPRESSION)) == strlen(EA_PROP_COMPRESSION)) {
+        const char lzo[] = "lzo";
+        const char zlib[] = "zlib";
+
+        if (bsxa->valuelen == strlen(lzo) && RtlCompareMemory(bsxa->data + bsxa->namelen, lzo, bsxa->valuelen) == bsxa->valuelen)
+            fcb->prop_compression = PropCompression_LZO;
+        else if (bsxa->valuelen == strlen(zlib) && RtlCompareMemory(bsxa->data + bsxa->namelen, zlib, bsxa->valuelen) == bsxa->valuelen)
+            fcb->prop_compression = PropCompression_Zlib;
+        else
+            fcb->prop_compression = PropCompression_None;
+
+        if (fcb->prop_compression != PropCompression_None) {
+            fcb->inode_item.flags |= BTRFS_INODE_COMPRESS;
+            fcb->inode_item_changed = TRUE;
+        }
+
+        fcb->prop_compression_changed = TRUE;
+        mark_fcb_dirty(fcb);
+
+        Status = STATUS_SUCCESS;
+        goto end;
+    } else if (bsxa->namelen >= strlen(stream_pref) && RtlCompareMemory(bsxa->data, stream_pref, strlen(stream_pref)) == strlen(stream_pref)) {
+        // don't allow xattrs beginning with user., as these appear as streams instead
+        Status = STATUS_OBJECT_NAME_INVALID;
+        goto end;
+    }
+
+    xa = ExAllocatePoolWithTag(PagedPool, offsetof(xattr, data[0]) + bsxa->namelen + bsxa->valuelen, ALLOC_TAG);
+    if (!xa) {
+        ERR("out of memory\n");
+        Status = STATUS_INSUFFICIENT_RESOURCES;
+        goto end;
+    }
+
+    le = fcb->xattrs.Flink;
+    while (le != &fcb->xattrs) {
+        xattr* xa2 = CONTAINING_RECORD(le, xattr, list_entry);
+
+        if (xa2->namelen == bsxa->namelen && RtlCompareMemory(xa2->data, bsxa->data, xa2->namelen) == xa2->namelen) {
+            RemoveEntryList(&xa2->list_entry);
+            ExFreePool(xa2);
+            break;
+        }
+
+        le = le->Flink;
+    }
+
+    xa->namelen = bsxa->namelen;
+    xa->valuelen = bsxa->valuelen;
+    xa->dirty = TRUE;
+    RtlCopyMemory(xa->data, bsxa->data, bsxa->namelen + bsxa->valuelen);
+
+    InsertTailList(&fcb->xattrs, &xa->list_entry);
+
+    fcb->xattrs_changed = TRUE;
+    mark_fcb_dirty(fcb);
+
+    Status = STATUS_SUCCESS;
+
+end:
+    ExReleaseResourceLite(fcb->Header.Resource);
+
+    ExReleaseResourceLite(&Vcb->tree_lock);
+
+    return Status;
+}
+
+static NTSTATUS reserve_subvol(device_extension* Vcb, PFILE_OBJECT FileObject, PIRP Irp) {
+    fcb* fcb;
+    ccb* ccb;
+
+    TRACE("(%p, %p)\n", Vcb, FileObject);
+
+    // "Reserving" a readonly subvol allows the calling process to write into it until the handle is closed.
+
+    if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), Irp->RequestorMode))
+        return STATUS_PRIVILEGE_NOT_HELD;
+
+    if (!FileObject || !FileObject->FsContext || !FileObject->FsContext2 || FileObject->FsContext == Vcb->volume_fcb)
+        return STATUS_INVALID_PARAMETER;
+
+    fcb = FileObject->FsContext;
+    ccb = FileObject->FsContext2;
+
+    if (!(fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY))
+        return STATUS_INVALID_PARAMETER;
+
+    if (fcb->subvol->reserved)
+        return STATUS_INVALID_PARAMETER;
+
+    fcb->subvol->reserved = PsGetCurrentProcess();
+    ccb->reserving = TRUE;
+
+    return STATUS_SUCCESS;
+}
+
+static NTSTATUS get_subvol_path(device_extension* Vcb, UINT64 id, WCHAR* out, ULONG outlen, PIRP Irp) {
+    LIST_ENTRY* le;
+    root* r = NULL;
+    NTSTATUS Status;
+    file_ref* fr;
+    UNICODE_STRING us;
+
+    le = Vcb->roots.Flink;
+    while (le != &Vcb->roots) {
+        root* r2 = CONTAINING_RECORD(le, root, list_entry);
+
+        if (r2->id == id) {
+            r = r2;
+            break;
+        }
+
+        le = le->Flink;
+    }
+
+    if (!r) {
+        ERR("couldn't find subvol %llx\n", id);
+        return STATUS_INTERNAL_ERROR;
+    }
+
+    ExAcquireResourceSharedLite(&Vcb->fcb_lock, TRUE);
+
+    Status = open_fileref_by_inode(Vcb, r, r->root_item.objid, &fr, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ExReleaseResourceLite(&Vcb->fcb_lock);
+        ERR("open_fileref_by_inode returned %08x\n", Status);
+        return Status;
+    }
+
+    us.Buffer = out;
+    us.Length = 0;
+    us.MaximumLength = (USHORT)min(0xffff, outlen) - sizeof(WCHAR);
+
+    Status = fileref_get_filename(fr, &us, NULL, NULL);
+
+    if (NT_SUCCESS(Status) || Status == STATUS_BUFFER_OVERFLOW)
+        out[us.Length / sizeof(WCHAR)] = 0;
+    else
+        ERR("fileref_get_filename returned %08x\n", Status);
+
+    free_fileref(Vcb, fr);
+
+    ExReleaseResourceLite(&Vcb->fcb_lock);
+
+    return Status;
+}
+
+static NTSTATUS find_subvol(device_extension* Vcb, void* in, ULONG inlen, void* out, ULONG outlen, PIRP Irp) {
+    btrfs_find_subvol* bfs;
+    NTSTATUS Status;
+    traverse_ptr tp;
+    KEY searchkey;
+
+    if (!in || inlen < sizeof(btrfs_find_subvol))
+        return STATUS_INVALID_PARAMETER;
+
+    if (!out || outlen < sizeof(WCHAR))
+        return STATUS_INVALID_PARAMETER;
+
+    if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), Irp->RequestorMode))
+        return STATUS_PRIVILEGE_NOT_HELD;
+
+    bfs = (btrfs_find_subvol*)in;
+
+    ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
+
+    if (!Vcb->uuid_root) {
+        ERR("couldn't find uuid root\n");
+        Status = STATUS_NOT_FOUND;
+        goto end;
+    }
+
+    RtlCopyMemory(&searchkey.obj_id, &bfs->uuid, sizeof(UINT64));
+    searchkey.obj_type = TYPE_SUBVOL_UUID;
+    RtlCopyMemory(&searchkey.offset, &bfs->uuid.uuid[sizeof(UINT64)], sizeof(UINT64));
+
+    Status = find_item(Vcb, Vcb->uuid_root, &tp, &searchkey, FALSE, Irp);
+
+    if (!NT_SUCCESS(Status)) {
+        ERR("find_item returned %08x\n", Status);
+        goto end;
+    }
+
+    if (!keycmp(searchkey, tp.item->key) && tp.item->size >= sizeof(UINT64)) {
+        UINT64* id = (UINT64*)tp.item->data;
+
+        if (bfs->ctransid != 0) {
+            KEY searchkey2;
+            traverse_ptr tp2;
+
+            searchkey2.obj_id = *id;
+            searchkey2.obj_type = TYPE_ROOT_ITEM;
+            searchkey2.offset = 0xffffffffffffffff;
+
+            Status = find_item(Vcb, Vcb->root_root, &tp2, &searchkey2, FALSE, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("find_item returned %08x\n", Status);
+                goto end;
+            }
+
+            if (tp2.item->key.obj_id == searchkey2.obj_id && tp2.item->key.obj_type == searchkey2.obj_type &&
+                tp2.item->size >= offsetof(ROOT_ITEM, otransid)) {
+                ROOT_ITEM* ri = (ROOT_ITEM*)tp2.item->data;
+
+                if (ri->ctransid == bfs->ctransid) {
+                    TRACE("found subvol %llx\n", *id);
+                    Status = get_subvol_path(Vcb, *id, out, outlen, Irp);
+                    goto end;
+                }
+            }
+        } else {
+            TRACE("found subvol %llx\n", *id);
+            Status = get_subvol_path(Vcb, *id, out, outlen, Irp);
+            goto end;
+        }
+    }
+
+    searchkey.obj_type = TYPE_SUBVOL_REC_UUID;
+
+    Status = find_item(Vcb, Vcb->uuid_root, &tp, &searchkey, FALSE, Irp);
+
+    if (!NT_SUCCESS(Status)) {
+        ERR("find_item returned %08x\n", Status);
+        goto end;
+    }
+
+    if (!keycmp(searchkey, tp.item->key) && tp.item->size >= sizeof(UINT64)) {
+        UINT64* ids = (UINT64*)tp.item->data;
+        ULONG i;
+
+        for (i = 0; i < tp.item->size / sizeof(UINT64); i++) {
+            if (bfs->ctransid != 0) {
+                KEY searchkey2;
+                traverse_ptr tp2;
+
+                searchkey2.obj_id = ids[i];
+                searchkey2.obj_type = TYPE_ROOT_ITEM;
+                searchkey2.offset = 0xffffffffffffffff;
+
+                Status = find_item(Vcb, Vcb->root_root, &tp2, &searchkey2, FALSE, Irp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("find_item returned %08x\n", Status);
+                    goto end;
+                }
+
+                if (tp2.item->key.obj_id == searchkey2.obj_id && tp2.item->key.obj_type == searchkey2.obj_type &&
+                    tp2.item->size >= offsetof(ROOT_ITEM, otransid)) {
+                    ROOT_ITEM* ri = (ROOT_ITEM*)tp2.item->data;
+
+                    if (ri->ctransid == bfs->ctransid) {
+                        TRACE("found subvol %llx\n", ids[i]);
+                        Status = get_subvol_path(Vcb, ids[i], out, outlen, Irp);
+                        goto end;
+                    }
+                }
+            } else {
+                TRACE("found subvol %llx\n", ids[i]);
+                Status = get_subvol_path(Vcb, ids[i], out, outlen, Irp);
+                goto end;
+            }
+        }
+    }
+
+    Status = STATUS_NOT_FOUND;
+
+end:
+    ExReleaseResourceLite(&Vcb->tree_lock);
+
+    return Status;
+}
+
+static NTSTATUS resize_device(device_extension* Vcb, void* data, ULONG len, PIRP Irp) {
+    btrfs_resize* br = (btrfs_resize*)data;
+    NTSTATUS Status;
+    LIST_ENTRY* le;
+    device* dev = NULL;
+
+    TRACE("(%p, %p, %u)\n", Vcb, data, len);
+
+    if (!data || len < sizeof(btrfs_resize) || (br->size % Vcb->superblock.sector_size) != 0)
+        return STATUS_INVALID_PARAMETER;
+
+    if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), Irp->RequestorMode))
+        return STATUS_PRIVILEGE_NOT_HELD;
+
+    if (Vcb->readonly)
+        return STATUS_MEDIA_WRITE_PROTECTED;
+
+    ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
+
+    le = Vcb->devices.Flink;
+    while (le != &Vcb->devices) {
+        device* dev2 = CONTAINING_RECORD(le, device, list_entry);
+
+        if (dev2->devitem.dev_id == br->device) {
+            dev = dev2;
+            break;
+        }
+
+        le = le->Flink;
+    }
+
+    if (!dev) {
+        ERR("could not find device %llx\n", br->device);
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
+    }
+
+    if (!dev->devobj) {
+        ERR("trying to resize missing device\n");
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
+    }
+
+    if (dev->readonly) {
+        ERR("trying to resize readonly device\n");
+        Status = STATUS_INVALID_PARAMETER;
+        goto end;
+    }
+
+    if (br->size > 0 && dev->devitem.num_bytes == br->size) {
+        TRACE("size unchanged, returning STATUS_SUCCESS\n");
+        Status = STATUS_SUCCESS;
+        goto end;
+    }
+
+    if (br->size > 0 && dev->devitem.num_bytes > br->size) { // shrink device
+        BOOL need_balance = TRUE;
+        UINT64 old_size, delta;
+
+        le = dev->space.Flink;
+        while (le != &dev->space) {
+            space* s = CONTAINING_RECORD(le, space, list_entry);
+
+            if (s->address <= br->size && s->address + s->size >= dev->devitem.num_bytes) {
+                need_balance = FALSE;
+                break;
+            }
+
+            le = le->Flink;
+        }
+
+        delta = dev->devitem.num_bytes - br->size;
+
+        if (need_balance) {
+            int i;
+
+            if (Vcb->balance.thread) {
+                WARN("balance already running\n");
+                Status = STATUS_DEVICE_NOT_READY;
+                goto end;
+            }
+
+            RtlZeroMemory(Vcb->balance.opts, sizeof(btrfs_balance_opts) * 3);
+
+            for (i = 0; i < 3; i++) {
+                Vcb->balance.opts[i].flags = BTRFS_BALANCE_OPTS_ENABLED | BTRFS_BALANCE_OPTS_DEVID | BTRFS_BALANCE_OPTS_DRANGE;
+                Vcb->balance.opts[i].devid = dev->devitem.dev_id;
+                Vcb->balance.opts[i].drange_start = br->size;
+                Vcb->balance.opts[i].drange_end = dev->devitem.num_bytes;
+            }
+
+            Vcb->balance.paused = FALSE;
+            Vcb->balance.shrinking = TRUE;
+            Vcb->balance.status = STATUS_SUCCESS;
+            KeInitializeEvent(&Vcb->balance.event, NotificationEvent, !Vcb->balance.paused);
+
+            space_list_subtract2(&dev->space, NULL, br->size, delta, NULL, NULL);
+
+            Status = PsCreateSystemThread(&Vcb->balance.thread, 0, NULL, NULL, NULL, balance_thread, Vcb);
+            if (!NT_SUCCESS(Status)) {
+                ERR("PsCreateSystemThread returned %08x\n", Status);
+                goto end;
+            }
+
+            Status = STATUS_MORE_PROCESSING_REQUIRED;
+
+            goto end;
+        }
+
+        old_size = dev->devitem.num_bytes;
+        dev->devitem.num_bytes = br->size;
+
+        Status = update_dev_item(Vcb, dev, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("update_dev_item returned %08x\n", Status);
+            dev->devitem.num_bytes = old_size;
+            goto end;
+        }
+
+        space_list_subtract2(&dev->space, NULL, br->size, delta, NULL, NULL);
+
+        Vcb->superblock.total_bytes -= delta;
+    } else { // extend device
+        GET_LENGTH_INFORMATION gli;
+        UINT64 old_size, delta;
+
+        Status = dev_ioctl(dev->devobj, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0,
+                           &gli, sizeof(gli), TRUE, NULL);
+        if (!NT_SUCCESS(Status)) {
+            ERR("IOCTL_DISK_GET_LENGTH_INFO returned %08x\n", Status);
+            goto end;
+        }
+
+        if (br->size == 0) {
+            br->size = gli.Length.QuadPart;
+
+            if (dev->devitem.num_bytes == br->size) {
+                TRACE("size unchanged, returning STATUS_SUCCESS\n");
+                Status = STATUS_SUCCESS;
+                goto end;
+            }
+
+            if (br->size == 0) {
+                ERR("IOCTL_DISK_GET_LENGTH_INFO returned 0 length\n");
+                Status = STATUS_INTERNAL_ERROR;
+                goto end;
+            }
+        } else if ((UINT64)gli.Length.QuadPart < br->size) {
+            ERR("device was %llx bytes, trying to extend to %llx\n", gli.Length.QuadPart, br->size);
+            Status = STATUS_INVALID_PARAMETER;
+            goto end;
+        }
+
+        delta = br->size - dev->devitem.num_bytes;
+
+        old_size = dev->devitem.num_bytes;
+        dev->devitem.num_bytes = br->size;
+
+        Status = update_dev_item(Vcb, dev, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("update_dev_item returned %08x\n", Status);
+            dev->devitem.num_bytes = old_size;
+            goto end;
+        }
+
+        space_list_add2(&dev->space, NULL, dev->devitem.num_bytes, delta, NULL, NULL);
+
+        Vcb->superblock.total_bytes += delta;
+    }
+
+    Status = STATUS_SUCCESS;
+    Vcb->need_write = TRUE;
+
+end:
+    ExReleaseResourceLite(&Vcb->tree_lock);
+
+    if (NT_SUCCESS(Status))
+        FsRtlNotifyVolumeEvent(Vcb->root_file, FSRTL_VOLUME_CHANGE_SIZE);
+
+    return Status;
+}
+
+NTSTATUS fsctl_request(PDEVICE_OBJECT DeviceObject, PIRP* Pirp, UINT32 type) {
+    PIRP Irp = *Pirp;
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     NTSTATUS Status;
-    
+
     switch (type) {
+#if (NTDDI_VERSION >= NTDDI_WIN7)
+        case FSCTL_REQUEST_OPLOCK:
+            WARN("STUB: FSCTL_REQUEST_OPLOCK\n");
+            Status = STATUS_INVALID_DEVICE_REQUEST;
+            break;
+#endif
+
         case FSCTL_REQUEST_OPLOCK_LEVEL_1:
             WARN("STUB: FSCTL_REQUEST_OPLOCK_LEVEL_1\n");
             Status = STATUS_INVALID_DEVICE_REQUEST;
